VERSION 5.00
Begin VB.UserControl NbrTextBox 
   BackColor       =   &H0080FFFF&
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1200
   ScaleHeight     =   495
   ScaleWidth      =   1200
   ToolboxBitmap   =   "NumberBox.ctx":0000
   Begin VB.TextBox txtNumberBox 
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "NbrTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' You have a royalty-free right to use, modify, reproduce and distribute
' the NumberBox code and OCX file (and/or any modified version) in any way
' you find useful, provided that you agree that Martin Liss has no warranty,
' obligations or liability for the NumberBox code and OCX file.

' 1.5 o Changed NumberBoxClick (event) to Click
'     o Changed NumberBoxKeyPress (event) to KeyPress
'     o Added KeyUp, KeyDown and Change events, and corrected DblClick
' 1.6 o Added parameters to KeyDown, KeyUp and KeyPress events.
' 1.7 o Added Enums for Alignment and BorderStyle properties
'     o Corrected problem where NumberBox behaved as if it was locked when data with decimal
'       points was added
'     o Added protection against pasting in invalid characters (which I thought it already had)
' 1.8 o Add ctrl-v support
'     o Allow unlimited decimals
' 1.9 o Add MaxValue and MinValue properties
' 1.10 o Fix bug where I forgot to handle SelStart after changing text
'      o Added DecimalSeparator property
' 1.11 o Changed the way a second decimal Separator is processed. Used to eliminate the 1st one. Now
'        the 2nd is not allowed.
'      o Corrected bug where if a decimal point were added at the beginning of -12345 it would
'        change to -.1 rather than -.12
' 1.12 o Corrected processing for comma as decimal Separator
'      o Changed Appearance property values so that they display Flat and 3D like the normal
'        textbox rather than 0 and 1
' 1.13 o Corrected MinValue and MaxValue processing so that the entry of a minus sign doesn't
'        result in a type mismatch error. Changed MinValue and MaxValue processing so that
'        old value is restored if change would exceed either limit. Corrected spelling of
'        "separator" (not annotated)
' 1.14 o Made .text the default property. This was done by going to Tools|Procedure Attributes,
'        choosing Text, clicking Advanced >>, and then choosing (Default) from the Procedure ID list.
'      o Added categories to properties
' 1.15 o Corrected problem where if number with a decimal separator was selected (highlighted) it
'        could not be cleared by enter the decimal separator since one was already there.
' 1.16 a) Add RequireLeadingDigit property
'      b) Remove MaxLength and PasswordChar properties
'      c) Changed behavior where if number was > MaxValue or < MinValue it dropped the last digit.
'         New behavior changes the value to MaxValue or MinValue as appropriate.
'-----------------------------------------------------------------------------------------
' Declare public events
Public Event Click()
Public Event DblClick()
Public Event Change()
'******* 1.6 or before Start *******
'Public Event KeyPress()
'Public Event KeyUp()
'Public Event KeyDown()
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
'******* 1.6 or before End *********
Private mbCanHaveDecimals As Boolean
Private mbCanBeNegative As Boolean
'******* 1.8 Start *******
'Private mintMaxDecimals As Integer
Private mstrMaxDecimals As String
'******* 1.8 End *********
'******* 1.9 Start *******
Private mdblMaxValue As Double
Private mdblMinValue As Double
'******* 1.9 End *********
'******* 1.10 Start *******
Private mintSeparator As Integer
'******* 1.10 End *********
'******* 1.7 Start *******
Private Const MINUS_SIGN = "-"
'******* 1.10 Start *******
'Private Const DECIMAL_POINT = "."
Private DecimalSep As String
'******* 1.10 End *********
'******* 1.13 Start *******
Private mstrOldValue As String
'******* 1.13 End *********
'******* 1.16a Start *******
Private mbRequireLD As Boolean
'******* 1.16a End *********

'Property Variables:
Dim m_DataSource As StdDataFormat
Dim m_DataFormat As IStdDataFormatDisp

Public Enum AlignmentPropertyValues
    [Left Justify]
    [Right Justify]
    Center
End Enum
Public Enum BorderStylePropertyValues
    None
    [Fixed Single]
End Enum
'******* 1.10 Start *******
Public Enum DecimalSeparatorValues
    Period
    Comma
End Enum
'******* 1.10 End *********
'******* 1.12 Start *******
Public Enum AppearanceValues
    Flat
    [3D]
End Enum
'******* 1.12 End *********

'******* 1.7 End *********
Public Property Get CanHaveDecimals() As Boolean
Attribute CanHaveDecimals.VB_Description = "Returns/sets a value which determines whether decimals are allowed in the number."
Attribute CanHaveDecimals.VB_ProcData.VB_Invoke_Property = ";Behavior"

    CanHaveDecimals = mbCanHaveDecimals
    
End Property
Public Property Let CanHaveDecimals(ByVal bTF As Boolean)

    mbCanHaveDecimals = bTF
    PropertyChanged "CanHaveDecimals"

End Property
Public Property Get CanBeNegative() As Boolean
Attribute CanBeNegative.VB_Description = "Returns/sets a value which determines whether the number can be negative."
Attribute CanBeNegative.VB_ProcData.VB_Invoke_Property = ";Behavior"

    CanBeNegative = mbCanBeNegative
    
End Property
Public Property Let CanBeNegative(ByVal bTF As Boolean)

    mbCanBeNegative = bTF
    PropertyChanged "CanBeNegative"

End Property
Public Property Get MaxDecimals() As String
Attribute MaxDecimals.VB_Description = "Returns/sets the maximum allowable number of decimal places. No limit if blank. Ignored if DecimalsOK is False."
Attribute MaxDecimals.VB_ProcData.VB_Invoke_Property = ";Behavior"

'******* 1.8 Start *******
'Public Property Get MaxDecimals() As Integer

'    MaxDecimals = mintMaxDecimals
'******* 1.8 End *********
    MaxDecimals = mstrMaxDecimals
    
End Property
Public Property Let MaxDecimals(ByVal strDecimals As String)

    If Trim$(strDecimals) = "" Then
        MaxDecimals = 9999
        PropertyChanged "MaxDecimals"
        Exit Property
    End If
    
    If strDecimals < "1" Then
        strDecimals = "1"
    End If
    
    mstrMaxDecimals = strDecimals

'Public Property Let MaxDecimals(ByVal intDecimals As Integer)
'
'    If intDecimals < 1 Then
'        intDecimals = 1
'    End If
'
'    mintMaxDecimals = intDecimals
    PropertyChanged "MaxDecimals"

End Property
'******* 1.10 Start *******
Public Property Get DecimalSeparator() As DecimalSeparatorValues
Attribute DecimalSeparator.VB_Description = "Returns/sets the value used to seperate decimals  (""."" or "","")"
Attribute DecimalSeparator.VB_ProcData.VB_Invoke_Property = ";Appearance"
    DecimalSeparator = mintSeparator
    
End Property
'******* 1.10 End *********
'******* 1.10 Start *******
Public Property Let DecimalSeparator(ByVal intSep As DecimalSeparatorValues)
    mintSeparator = intSep
    If intSep = 0 Then
        DecimalSep = "."
    Else
        DecimalSep = ","
    End If
    PropertyChanged "DecimalSeparator"

End Property
'******* 1.10 End *********

Private Sub txtNumberBox_Change()

    RaiseEvent Change
    '******* 1.7 Start *******
    Dim lngIndex As Long
    Dim intDecPos As Integer
    Dim bIsToRight As Boolean
    '******* 1.8 Start *******
    Dim DecimalMaximum As Integer
    
    If MaxDecimals = "" Then
        DecimalMaximum = 9999
    Else
        DecimalMaximum = CInt(MaxDecimals)
    End If
    '******* 1.8 End *********
    
    bIsToRight = False
    '******* 1.10 Start *******
'    intDecPos = InStr(1, txtNumberBox.Text, DECIMAL_POINT)
    intDecPos = InStr(1, txtNumberBox.Text, DecimalSep)
    '******* 1.10 End *********

    If intDecPos > 0 Then
        If txtNumberBox.SelStart > intDecPos Then
            bIsToRight = True
        End If
    End If
    
    For lngIndex = 1 To Len(txtNumberBox.Text)
        Select Case Mid$(txtNumberBox.Text, lngIndex, 1)
            Case "0" To "9"
                If bIsToRight Then
'******* 1.8 Start *******
'                    If Len(txtNumberBox.Text) - intDecPos > MaxDecimals Then
                    If Len(txtNumberBox.Text) - intDecPos > DecimalMaximum Then
'******* 1.8 End *********
                        ' There are too many characters to the right of the
                        ' decimal point and so we need to get rid of one.
                        Select Case True
                            Case InStr(txtNumberBox.Text, MINUS_SIGN) ' ist look for out of place "- "
                                ' Remove it and put one in front
                                txtNumberBox.Text = MINUS_SIGN & Replace(txtNumberBox.Text, MINUS_SIGN, "")
                                '******* 1.10 Start *******
                                txtNumberBox.SelStart = Len(txtNumberBox.Text)
                                '******* 1.10 End *********
                            '******* 1.10 Start *******
'                            Case InStr(txtNumberBox.Text, DECIMAL_POINT) ' Then look for decimal point
'                                If Len(txtNumberBox.Text) - Len(Replace(txtNumberBox.Text, DECIMAL_POINT, "")) > 1 Then
                            Case InStr(txtNumberBox.Text, DecimalSep) ' Then look for decimal point
                                If Len(txtNumberBox.Text) - Len(Replace(txtNumberBox.Text, DecimalSep, "")) > 1 Then
                            '******* 1.10 End *********
                                ' There's more than one so strip the one after the first one
                                '******* 1.10 Start *******
'                                    txtNumberBox.Text = Replace(txtNumberBox.Text, DECIMAL_POINT, "", , 1)
                                    txtNumberBox.Text = Replace(txtNumberBox.Text, DecimalSep, "", , 1)
                                '******* 1.10 End *********
                                    txtNumberBox.SelStart = Len(txtNumberBox.Text)
                                Else
                                    txtNumberBox.Text = Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - 1)
                                    txtNumberBox.SelStart = Len(txtNumberBox.Text)
                                End If
                            Case Else
                                txtNumberBox.Text = Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - 1)
                                txtNumberBox.SelStart = Len(txtNumberBox.Text)
                        End Select
                    End If
                End If
            Case "-"
                If CanBeNegative Then
                    If Len(txtNumberBox.Text) - Len(Replace(txtNumberBox.Text, MINUS_SIGN, "")) > 1 Or _
                       lngIndex <> 1 Then
                        ' There's more than 1 negative sign or the negative sign
                        ' is in the wrong placestrip them and put one in front
                        txtNumberBox.Text = MINUS_SIGN & Replace(txtNumberBox.Text, MINUS_SIGN, "")
                        txtNumberBox.SelStart = Len(txtNumberBox.Text)
                    End If
                Else
                    ' Remove the minus sign
                    txtNumberBox.Text = Left$(txtNumberBox.Text, lngIndex - 1) & _
                                 Right$(txtNumberBox.Text, Len(txtNumberBox.Text) - lngIndex)
                    txtNumberBox.SelStart = Len(txtNumberBox.Text)
                End If
            '******* 1.10 Start *******
'            Case "."
            Case DecimalSep
            '******* 1.10 End *********
                If CanHaveDecimals Then
                    '******* 1.10 Start *******
'                    If Len(txtNumberBox.Text) - Len(Replace(txtNumberBox.Text, DECIMAL_POINT, "")) > 1 Then
'                        ' There's more than 1 decimal point so strip one off
'                        txtNumberBox.Text = Replace(txtNumberBox.Text, DECIMAL_POINT, "", , 1)
                    If Len(txtNumberBox.Text) - Len(Replace(txtNumberBox.Text, DecimalSep, "")) > 1 Then
                        ' There's more than 1 decimal point so strip one off
                        txtNumberBox.Text = Replace(txtNumberBox.Text, DecimalSep, "", , 1)
                    '******* 1.10 End *********
                        txtNumberBox.SelStart = Len(txtNumberBox.Text)
                        '******* 1.8 Start *******
                        'ElseIf Len(txtNumberBox.Text) - lngIndex > MaxDecimals Then
                        ElseIf Len(txtNumberBox.Text) - lngIndex > DecimalMaximum Then
                        '******* 1.8 End *********
                            ' There are too many decimals so strip off the extra ones
                            '******* 1.8 Start *******
'                            txtNumberBox.Text = Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - _
'                                              ((Len(txtNumberBox.Text) - lngIndex) - MaxDecimals))
                            '******* 1.11 Start *******
'                            txtNumberBox.Text = Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - _
'                                              ((Len(txtNumberBox.Text) - lngIndex) - DecimalMaximum))
                            If InStr(1, txtNumberBox.Text, "-") Then
                                txtNumberBox.Text = Replace(txtNumberBox.Text, "-", "")
                                txtNumberBox.Text = "-" & Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - _
                                                  ((Len(txtNumberBox.Text) - lngIndex) - DecimalMaximum))
                            '******* 1.11 End *********
                            Else
                                txtNumberBox.Text = Left$(txtNumberBox.Text, Len(txtNumberBox.Text) - _
                                                  ((Len(txtNumberBox.Text) - lngIndex) - DecimalMaximum))
                            End If
                                              
                            '******* 1.8 End *********
                            '******* 1.10 Start *******
                            txtNumberBox.SelStart = Len(txtNumberBox.Text)
                            '******* 1.10 End *********
                    End If
                Else
                    ' Remove the decimal point
                    '******* 1.10 Start *******
'                    txtNumberBox.Text = Replace(txtNumberBox.Text, DECIMAL_POINT, "")
                    txtNumberBox.Text = Replace(txtNumberBox.Text, DecimalSep, "")
                    '******* 1.10 End *********
                    txtNumberBox.SelStart = Len(txtNumberBox.Text)
                End If
            Case Else
                ' Remove whatever it is
                If lngIndex <= Len(txtNumberBox.Text) Then ' Somehow it get's greater
                    txtNumberBox.Text = VBA.Left$(txtNumberBox.Text, lngIndex - 1) & Right$(txtNumberBox.Text, Len(txtNumberBox.Text) - lngIndex)
                End If
        End Select
    Next
    '******* 1.7 End *********
End Sub

Private Sub txtNumberBox_Click()
    ' Raise a Click event whenever the user presses
    ' a key
    RaiseEvent Click

End Sub

Private Sub txtNumberBox_DblClick()
  
    RaiseEvent DblClick
    
End Sub

Private Sub txtNumberBox_KeyDown(KeyCode As Integer, Shift As Integer)

    '******* 1.6 or before Start *******
'    RaiseEvent KeyDown
    RaiseEvent KeyDown(KeyCode, Shift)
    '******* 1.6 or before End *********

    '******* 1.7 Start *******
    Dim ShiftKey As Integer
    ShiftKey = Shift And 7
    Select Case ShiftKey
        Case 2 ' CTRL key
            Select Case KeyCode
                Case 67  ' "C" (copy)
                    Clipboard.Clear
                    Clipboard.SetText txtNumberBox.SelText
                Case 86  ' "V" (paste)
                    '******* 1.8 Start *******
'                    txtNumberBox.SelText = Clipboard.GetText()
                    txtNumberBox.SelText = Clipboard.GetText()
                    '******* 1.8 End *********
                Case 88  ' "X" (cut)
                    Clipboard.Clear
                    Clipboard.SetText txtNumberBox.SelText
                    txtNumberBox.SelText = ""
            End Select
    End Select
    '******* 1.7 End *********

End Sub

Private Sub txtNumberBox_KeyPress(KeyAscii As Integer)

    Dim intPos As Integer

    ' Raise a KeyPress event whenever the user presses
    ' a key
    '******* 1.6 or before Start *******
'    RaiseEvent KeyPress
    RaiseEvent KeyPress(KeyAscii)
    '******* 1.6 or before End *********
    '******* 1.13 Start *******
    mstrOldValue = txtNumberBox.Text
    '******* 1.13 End *********

'******* 1.7 Start *******
    ' Made global
'    Const MINUS_SIGN = "-"
'    Const DECIMAL_POINT = "."

'    Select Case KeyAscii
'        Case 8 ' Backspace
'            ' Backspace is always OK
'        Case 48 To 57 ' 0 to 9
'            ' These are always OK unless the number of decimals exceeds
'            ' the allowed amount
'            intPos = InStr(1, txtNumberBox, DECIMAL_POINT)
'
'            'MsgBox "selstart = " & txtNumberBox.SelStart & "   intPos = " & intPos
'
'            If intPos > 0 Then
'                If Len(txtNumberBox.Text) - intPos = MaxDecimals Then
'                    ' We already are at the maximum number of decimals
'                    '******* 1.7 Start *******
'                    ' We can add numbers before the decimal point but not after
''                    KeyAscii = 0
''                    Beep
'                    If txtNumberBox.SelStart > intPos Then
'                        KeyAscii = 0
'                        Beep
'                    End If
'                    '******* 1.7 End *********
'                End If
'            End If
'        Case 46 ' Decimal-point
'            If CanHaveDecimals Then
'                If InStr(1, txtNumberBox, DECIMAL_POINT) Then
'                    ' There is already a DECIMAL_POINT
'                    KeyAscii = 0
'                    Beep
'                ElseIf (txtNumberBox.SelStart < (Len(txtNumberBox) - MaxDecimals)) Then
'                    KeyAscii = 0
'                    Beep
'                Else
'                    KeyAscii = KeyAscii
'                End If
'            Else
'                KeyAscii = 0
'                Beep
'            End If
'        Case 45 ' Minus-sign
'            If CanBeNegative Then
'                If InStr(1, txtNumberBox, MINUS_SIGN) Or txtNumberBox.SelStart <> 0 Then
'                    ' There is already a minus-sign or the minus-sign is not in pos 1
'                    KeyAscii = 0
'                    Beep
'                Else
'                    KeyAscii = KeyAscii
'                End If
'            Else
'                KeyAscii = 0
'                Beep
'            End If
'        Case Else
'            KeyAscii = 0
'            Beep
'    End Select

    '******* 1.10 Start *******
    ' 46 (period) and 44 (comma) are okay depending on the DecimalSeparator setting
    If (KeyAscii = 46 And DecimalSep = ".") Or (KeyAscii = 44 And DecimalSep = ",") Then
        '******* 1.11 Start *******
        ' Unless there is already one present
        If InStr(1, txtNumberBox.Text, DecimalSep) Then
            '******* 1.15 Start *******
'            KeyAscii = 0
'            Beep
'            Exit Sub
            ' See if the text selected for replacement contains the decimal separator
            If InStr(1, Mid$(txtNumberBox.Text, txtNumberBox.SelStart + 1, txtNumberBox.SelLength), DecimalSep) Then
                ' It's okay to enter a decimal separator since the text being replaced contains
                ' the decimal separator
            Else
                KeyAscii = 0
                Beep
                Exit Sub
            End If
            '******* 1.15 End *********
        End If
        '******* 1.11 End *********
        
        Exit Sub
    End If
    '******* 1.10 End *********
    
    Select Case KeyAscii
        '******* 1.10 Start *******
'        Case 8, 45, 46, 48 To 57
            ' Backspace, Minus-sign, Decimal-point and 0 to 9 are okay
        Case 8, 45, 48 To 57
            ' Backspace, Minus-sign and 0 to 9 are okay
        '******* 1.10 End *********
        Case Else
            KeyAscii = 0
            Beep
    End Select
'******* 1.7 End *********
    '******* 1.16a Start *******
    If RequireLeadingDigit Then
        If Left$(txtNumberBox.Text, 1) = DecimalSep Then
            txtNumberBox.Text = "0" & txtNumberBox.Text
            txtNumberBox.SelStart = Len(txtNumberBox.Text)
        End If
    End If
    '******* 1.16a End *********

End Sub

Private Sub txtNumberBox_KeyUp(KeyCode As Integer, Shift As Integer)

    '******* 1.6 or before Start *******
'    RaiseEvent KeyUp
    RaiseEvent KeyUp(KeyCode, Shift)
    '******* 1.6 or before End *********
    '******* 1.9 Start *******
    If MaxValue = 0 And MinValue = 0 Then
        Exit Sub
    End If
    
    '******* 1.13 Start *******
    If Trim$(txtNumberBox.Text) = MINUS_SIGN Or Trim$(txtNumberBox.Text) = "" Then
        Exit Sub
    End If
    '******* 1.13 End *********
    
    '******* 1.12 Start *******
'    If Val(txtNumberBox.Text) > MaxValue Then
'        txtNumberBox.Text = MaxValue
'    End If
'
'    If Val(txtNumberBox.Text) < MinValue Then
'        txtNumberBox.Text = MinValue
'    End If
    '******* 1.13 Start *******
'    If CDbl(txtNumberBox.Text) > MaxValue Then
'        txtNumberBox.Text = MaxValue
    '******* 1.16a Start *******
'    If CDbl(txtNumberBox.Text) > MaxValue And MaxValue <> 0 Then
'        If mstrOldValue = MINUS_SIGN Then
'            txtNumberBox.Text = MaxValue
'        Else
'            txtNumberBox.Text = mstrOldValue
'        End If
    If Left$(txtNumberBox.Text, 1) <> DecimalSep Then
        If CDbl(txtNumberBox.Text) > MaxValue And MaxValue <> 0 Then
'           ******* 1.16c Start *******
'            If mstrOldValue = MINUS_SIGN Then
'                txtNumberBox.Text = MaxValue
'            Else
'                txtNumberBox.Text = mstrOldValue
'            End If
            txtNumberBox.Text = MaxValue
'           ******* 1.16c End *********
        End If
    '******* 1.16a End *********
    '******* 1.13 End *********
    End If
    
    '******* 1.13 Start *******
'    If CDbl(txtNumberBox.Text) < MinValue Then
'        txtNumberBox.Text = MinValue
    '******* 1.16a Start *******
    '******* 1.16a Start *******
'    If CDbl(txtNumberBox.Text) < MinValue And MinValue <> 0 Then
'        If mstrOldValue = MINUS_SIGN Then
'            txtNumberBox.Text = MinValue
'        Else
'            txtNumberBox.Text = mstrOldValue
'        End If
    If Left$(txtNumberBox.Text, 1) <> DecimalSep Then
        If CDbl(txtNumberBox.Text) < MinValue And MinValue <> 0 Then
'           ******* 1.16c Start *******
'            If mstrOldValue = MINUS_SIGN Then
'                txtNumberBox.Text = MinValue
'            Else
'                txtNumberBox.Text = mstrOldValue
'            End If
            txtNumberBox.Text = MinValue
'           ******* 1.16c End *********
        End If
    '******* 1.16a End *********
    '******* 1.13 End *********
    End If
    '******* 1.12 End *********
    '******* 1.9 End *********
    
End Sub

Private Sub UserControl_Initialize()

    CanHaveDecimals = True
    CanBeNegative = True
    '******* 1.8 Start *******
    'MaxDecimals = 2
    MaxDecimals = "2"
    '******* 1.8 End *********
    '******* 1.9 Start *******
    MaxValue = 0
    MinValue = 0
    '******* 1.9 End *********
    '******* 1.16a Start *******
    RequireLeadingDigit = True
    '******* 1.16a End *********

End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    CanHaveDecimals = PropBag.ReadProperty("CanHaveDecimals", True)
    CanBeNegative = PropBag.ReadProperty("CanBeNegative", True)
'******* 1.8 Start *******
'    MaxDecimals = PropBag.ReadProperty("MaxDecimals", 2)
    MaxDecimals = PropBag.ReadProperty("MaxDecimals", "2")
'******* 1.8 End *********
    '******* 1.9 Start *******
    MaxValue = PropBag.ReadProperty("MaxValue", 0)
    MinValue = PropBag.ReadProperty("MinValue", 0)
    '******* 1.9 End *********
    '******* 1.10 Start *******
    DecimalSeparator = PropBag.ReadProperty("DecimalSeparator", ".")
    '******* 1.10 End *********
    '******* 1.16a Start *******
    RequireLeadingDigit = PropBag.ReadProperty("RequireLeadingDigit", True)
    '******* 1.16a End *********
'    txtNumberBox.Text = PropBag.ReadProperty("Text", "")
    txtNumberBox.Text = PropBag.ReadProperty("Text", 0)
    
    txtNumberBox.CausesValidation = PropBag.ReadProperty("CausesValidation", True)
    txtNumberBox.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    txtNumberBox.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    txtNumberBox.Appearance = PropBag.ReadProperty("Appearance", 1)
    txtNumberBox.Alignment = PropBag.ReadProperty("Alignment", 0)
    txtNumberBox.DataMember = PropBag.ReadProperty("DataMember", "")
    txtNumberBox.Enabled = PropBag.ReadProperty("Enabled", True)
    txtNumberBox.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    Set txtNumberBox.Font = PropBag.ReadProperty("Font", Ambient.Font)
    txtNumberBox.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    '******* 1.16b Start *******
'    txtNumberBox.MaxLength = PropBag.ReadProperty("MaxLength", 0)
    '******* 1.16b End *********
    txtNumberBox.Locked = PropBag.ReadProperty("Locked", False)
    txtNumberBox.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    txtNumberBox.OLEDragMode = PropBag.ReadProperty("OLEDragMode", 0)
    txtNumberBox.RightToLeft = PropBag.ReadProperty("RightToLeft", False)
    '******* 1.16b Start *******
'    txtNumberBox.PasswordChar = PropBag.ReadProperty("PasswordChar", "")
    '******* 1.16b End *********
    txtNumberBox.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    Set m_DataSource = PropBag.ReadProperty("DataSource", Nothing)
    Set m_DataFormat = PropBag.ReadProperty("DataFormat", Nothing)
    txtNumberBox.SelText = PropBag.ReadProperty("SelText", "")
    txtNumberBox.SelStart = PropBag.ReadProperty("SelStart", 0)
    txtNumberBox.SelLength = PropBag.ReadProperty("SelLength", 0)
    txtNumberBox.WhatsThisHelpID = PropBag.ReadProperty("WhatsThisHelpID", 0)
    txtNumberBox.LinkTopic = PropBag.ReadProperty("LinkTopic", "")
    txtNumberBox.LinkTimeout = PropBag.ReadProperty("LinkTimeout", 50)
    txtNumberBox.LinkMode = PropBag.ReadProperty("LinkMode", 0)
    txtNumberBox.LinkItem = PropBag.ReadProperty("LinkItem", "")
End Sub


Private Sub UserControl_Resize()

    txtNumberBox.Width = UserControl.Width
    txtNumberBox.Height = UserControl.Height
   
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "CanHaveDecimals", CanHaveDecimals, True
    PropBag.WriteProperty "CanBeNegative", CanBeNegative, True
    '******* 1.8 Start *******
'    PropBag.WriteProperty "MaxDecimals", MaxDecimals, 2
    PropBag.WriteProperty "MaxDecimals", MaxDecimals, "2"
    '******* 1.8 End *********
    '******* 1.9 Start *******
    PropBag.WriteProperty "MaxValue", MaxValue, 0
    PropBag.WriteProperty "MinValue", MinValue, 0
    '******* 1.9 End *********
    '******* 1.10 Start *******
    PropBag.WriteProperty "DecimalSeparator", DecimalSeparator, "."
    '******* 1.10 End *********
    '******* 1.16a Start *******
    PropBag.WriteProperty "RequireLeadingDigit", RequireLeadingDigit, True
    '******* 1.16a End *********
    
'    Call PropBag.WriteProperty("Text", txtNumberBox.Text, "")
    Call PropBag.WriteProperty("Text", Text, 0)
    
    Call PropBag.WriteProperty("CausesValidation", txtNumberBox.CausesValidation, True)
    Call PropBag.WriteProperty("BorderStyle", txtNumberBox.BorderStyle, 1)
    Call PropBag.WriteProperty("BackColor", txtNumberBox.BackColor, &H80000005)
    Call PropBag.WriteProperty("Appearance", txtNumberBox.Appearance, 1)
    Call PropBag.WriteProperty("Alignment", txtNumberBox.Alignment, 0)
    Call PropBag.WriteProperty("DataMember", txtNumberBox.DataMember, "")
    Call PropBag.WriteProperty("Enabled", txtNumberBox.Enabled, True)
    Call PropBag.WriteProperty("ForeColor", txtNumberBox.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Font", txtNumberBox.Font, Ambient.Font)
    Call PropBag.WriteProperty("MousePointer", txtNumberBox.MousePointer, 0)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    '******* 1.16b Start *******
'    Call PropBag.WriteProperty("MaxLength", txtNumberBox.MaxLength, 0)
    '******* 1.16b End *********
    Call PropBag.WriteProperty("Locked", txtNumberBox.Locked, False)
    Call PropBag.WriteProperty("OLEDropMode", txtNumberBox.OLEDropMode, 0)
    Call PropBag.WriteProperty("OLEDragMode", txtNumberBox.OLEDragMode, 0)
    Call PropBag.WriteProperty("RightToLeft", txtNumberBox.RightToLeft, False)
    '******* 1.16b Start *******
'    Call PropBag.WriteProperty("PasswordChar", txtNumberBox.PasswordChar, "")
    '******* 1.16b End *********
    Call PropBag.WriteProperty("ToolTipText", txtNumberBox.ToolTipText, "")
    Call PropBag.WriteProperty("DataSource", m_DataSource, Nothing)
    Call PropBag.WriteProperty("DataFormat", m_DataFormat, Nothing)
    Call PropBag.WriteProperty("SelText", txtNumberBox.SelText, "")
    Call PropBag.WriteProperty("SelStart", txtNumberBox.SelStart, 0)
    Call PropBag.WriteProperty("SelLength", txtNumberBox.SelLength, 0)
    Call PropBag.WriteProperty("WhatsThisHelpID", txtNumberBox.WhatsThisHelpID, 0)
    Call PropBag.WriteProperty("LinkTopic", txtNumberBox.LinkTopic, "")
    Call PropBag.WriteProperty("LinkTimeout", txtNumberBox.LinkTimeout, 50)
    Call PropBag.WriteProperty("LinkMode", txtNumberBox.LinkMode, 0)
    Call PropBag.WriteProperty("LinkItem", txtNumberBox.LinkItem, "")
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Text
'Public Property Get Text() As String
Public Property Get Text() As Variant
Attribute Text.VB_Description = "Returns/Sets the number contained in the control."
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Text.VB_UserMemId = 0
Attribute Text.VB_MemberFlags = "200"

    Text = txtNumberBox.Text
End Property
'Public Property Let Text(ByVal New_Text As String)
Public Property Let Text(ByVal New_Text As Variant)

    txtNumberBox.Text() = New_Text
    PropertyChanged "Text"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,CausesValidation
Public Property Get CausesValidation() As Boolean
Attribute CausesValidation.VB_Description = "Returns/sets whether validation occurs on the control which lost focus."
Attribute CausesValidation.VB_ProcData.VB_Invoke_Property = ";Behavior"
    CausesValidation = txtNumberBox.CausesValidation
End Property

Public Property Let CausesValidation(ByVal New_CausesValidation As Boolean)
    txtNumberBox.CausesValidation() = New_CausesValidation
    PropertyChanged "CausesValidation"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,BorderStyle
'******* 1.7 Start *******
'Public Property Get BorderStyle() As Integer
Public Property Get BorderStyle() As BorderStylePropertyValues
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
'******* 1.7 End *********
    BorderStyle = txtNumberBox.BorderStyle
End Property
'******* 1.7 Start *******
'Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
Public Property Let BorderStyle(ByVal New_BorderStyle As BorderStylePropertyValues)
'******* 1.7 End *********
    txtNumberBox.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BackColor = txtNumberBox.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    txtNumberBox.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Appearance
'******* 1.12 Start *******
'Public Property Get Appearance() As Integer
Public Property Get Appearance() As AppearanceValues
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
'******* 1.12 End *********

    Appearance = txtNumberBox.Appearance
End Property

'******* 1.12 Start *******
'Public Property Let Appearance(ByVal New_Appearance As Integer)
Public Property Let Appearance(ByVal New_Appearance As AppearanceValues)
'******* 1.12 End *********

    txtNumberBox.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Alignment
'******* 1.7 Start *******
'Public Property Get Alignment() As Integer
Public Property Get Alignment() As AlignmentPropertyValues
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
Attribute Alignment.VB_ProcData.VB_Invoke_Property = ";Misc"
'******* 1.7 End *********
    Alignment = txtNumberBox.Alignment
End Property
'******* 1.7 Start *******
'Public Property Let Alignment(ByVal New_Alignment As Integer)
Public Property Let Alignment(ByVal New_Alignment As AlignmentPropertyValues)
'******* 1.7 End *********
    txtNumberBox.Alignment() = New_Alignment
    PropertyChanged "Alignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,DataMember
Public Property Get DataMember() As String
Attribute DataMember.VB_Description = "Returns/sets a value that describes the DataMember for a data connection."
Attribute DataMember.VB_ProcData.VB_Invoke_Property = ";Data"
    DataMember = txtNumberBox.DataMember
End Property

Public Property Let DataMember(ByVal New_DataMember As String)
    txtNumberBox.DataMember() = New_DataMember
    PropertyChanged "DataMember"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = txtNumberBox.Enabled

End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    
    txtNumberBox.Enabled() = New_Enabled
    PropertyChanged "Enabled"
    
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    ForeColor = txtNumberBox.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    txtNumberBox.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = txtNumberBox.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set txtNumberBox.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,HideSelection
Public Property Get HideSelection() As Boolean
Attribute HideSelection.VB_Description = "Specifies whether the selection in a Masked edit control is hidden when the control loses focus."
Attribute HideSelection.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HideSelection = txtNumberBox.HideSelection
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = txtNumberBox.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    txtNumberBox.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = txtNumberBox.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set txtNumberBox.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'******* 1.16b Start *******
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,MaxLength
'Public Property Get MaxLength() As Long
'    MaxLength = txtNumberBox.MaxLength
'End Property
'Public Property Let MaxLength(ByVal New_MaxLength As Long)
'    txtNumberBox.MaxLength() = New_MaxLength
'    PropertyChanged "MaxLength"
'End Property
'******* 1.16b End *********

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,Locked
Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
Attribute Locked.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Locked = txtNumberBox.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    txtNumberBox.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,OLEDropMode
Public Property Get OLEDropMode() As Integer
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this object can act as an OLE drop target, and whether this takes place automatically or under programmatic control."
Attribute OLEDropMode.VB_ProcData.VB_Invoke_Property = ";Behavior"
    OLEDropMode = txtNumberBox.OLEDropMode
End Property

Public Property Let OLEDropMode(ByVal New_OLEDropMode As Integer)
    txtNumberBox.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,OLEDragMode
Public Property Get OLEDragMode() As Integer
Attribute OLEDragMode.VB_Description = "Returns/Sets whether this object can act as an OLE drag/drop source, and whether this process is started automatically or under programmatic control."
Attribute OLEDragMode.VB_ProcData.VB_Invoke_Property = ";Behavior"
    OLEDragMode = txtNumberBox.OLEDragMode
End Property

Public Property Let OLEDragMode(ByVal New_OLEDragMode As Integer)
    txtNumberBox.OLEDragMode() = New_OLEDragMode
    PropertyChanged "OLEDragMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,MultiLine
Public Property Get MultiLine() As Boolean
Attribute MultiLine.VB_Description = "Returns/sets a value that determines whether a control can accept multiple lines of text."
Attribute MultiLine.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MultiLine = txtNumberBox.MultiLine
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,RightToLeft
Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
Attribute RightToLeft.VB_ProcData.VB_Invoke_Property = ";Behavior"
    RightToLeft = txtNumberBox.RightToLeft
End Property

Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    txtNumberBox.RightToLeft() = New_RightToLeft
    PropertyChanged "RightToLeft"
End Property

'******* 1.16b Start *******
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=txtNumberBox,txtNumberBox,-1,PasswordChar
'Public Property Get PasswordChar() As String
'    PasswordChar = txtNumberBox.PasswordChar
'End Property
'
'Public Property Let PasswordChar(ByVal New_PasswordChar As String)
'    txtNumberBox.PasswordChar() = New_PasswordChar
'    PropertyChanged "PasswordChar"
'End Property
'******* 1.16b End *********

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,ScrollBars
Public Property Get ScrollBars() As Integer
Attribute ScrollBars.VB_Description = "Returns/sets a value indicating whether an object has vertical or horizontal scroll bars."
Attribute ScrollBars.VB_ProcData.VB_Invoke_Property = ";Behavior"
    ScrollBars = txtNumberBox.ScrollBars
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = ";Misc"
    ToolTipText = txtNumberBox.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    txtNumberBox.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=22,0,0,0
Public Property Get DataSource() As StdDataFormat 'DataSource
Attribute DataSource.VB_ProcData.VB_Invoke_Property = ";Data"
    Set DataSource = m_DataSource
End Property

Public Property Set DataSource(ByVal New_DataSource As StdDataFormat) 'DataSource)
    Set m_DataSource = New_DataSource
    PropertyChanged "DataSource"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=21,0,0,0
Public Property Get DataFormat() As IStdDataFormatDisp
Attribute DataFormat.VB_ProcData.VB_Invoke_Property = ";Data"
    Set DataFormat = m_DataFormat
End Property

Public Property Set DataFormat(ByVal New_DataFormat As IStdDataFormatDisp)
    Set m_DataFormat = New_DataFormat
    PropertyChanged "DataFormat"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,SelText
Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
    SelText = txtNumberBox.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    txtNumberBox.SelText() = New_SelText
    PropertyChanged "SelText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,SelStart
Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
    SelStart = txtNumberBox.SelStart
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    txtNumberBox.SelStart() = New_SelStart
    PropertyChanged "SelStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,SelLength
Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
    SelLength = txtNumberBox.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    txtNumberBox.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,WhatsThisHelpID
Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
Attribute WhatsThisHelpID.VB_ProcData.VB_Invoke_Property = ";Misc"
    WhatsThisHelpID = txtNumberBox.WhatsThisHelpID
End Property

Public Property Let WhatsThisHelpID(ByVal New_WhatsThisHelpID As Long)
    txtNumberBox.WhatsThisHelpID() = New_WhatsThisHelpID
    PropertyChanged "WhatsThisHelpID"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,LinkTopic
Public Property Get LinkTopic() As String
Attribute LinkTopic.VB_Description = "Returns/sets the source application and topic for a destination control."
Attribute LinkTopic.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkTopic = txtNumberBox.LinkTopic
End Property

Public Property Let LinkTopic(ByVal New_LinkTopic As String)
    txtNumberBox.LinkTopic() = New_LinkTopic
    PropertyChanged "LinkTopic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,LinkTimeout
Public Property Get LinkTimeout() As Integer
Attribute LinkTimeout.VB_Description = "Returns/sets the amount of time a control waits for a response to a DDE message."
Attribute LinkTimeout.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkTimeout = txtNumberBox.LinkTimeout
End Property

Public Property Let LinkTimeout(ByVal New_LinkTimeout As Integer)
    txtNumberBox.LinkTimeout() = New_LinkTimeout
    PropertyChanged "LinkTimeout"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,LinkMode
Public Property Get LinkMode() As Integer
Attribute LinkMode.VB_Description = "Returns/sets the type of link used for a DDE conversation and activates the connection."
Attribute LinkMode.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkMode = txtNumberBox.LinkMode
End Property

Public Property Let LinkMode(ByVal New_LinkMode As Integer)
    txtNumberBox.LinkMode() = New_LinkMode
    PropertyChanged "LinkMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtNumberBox,txtNumberBox,-1,LinkItem
Public Property Get LinkItem() As String
Attribute LinkItem.VB_Description = "Returns/sets the data passed to a destination control in a DDE conversation with another application."
Attribute LinkItem.VB_ProcData.VB_Invoke_Property = ";DDE"
    LinkItem = txtNumberBox.LinkItem
End Property

Public Property Let LinkItem(ByVal New_LinkItem As String)
    txtNumberBox.LinkItem() = New_LinkItem
    PropertyChanged "LinkItem"
End Property

'******* 1.9 Start *******
Public Property Get MaxValue() As Double
Attribute MaxValue.VB_Description = "Returns/sets the maximum allowable value."
Attribute MaxValue.VB_ProcData.VB_Invoke_Property = ";Behavior"

    MaxValue = mdblMaxValue
    
End Property

Public Property Let MaxValue(ByVal dblNew As Double)

    '******* 1.13 Start *******
'    If dblNew < MinValue Then
    If dblNew < MinValue And MinValue <> 0 Then
    '******* 1.13 End *********
        dblNew = MinValue
    End If
    
    mdblMaxValue = dblNew
    PropertyChanged "MaxValue"
    
End Property
Public Property Get MinValue() As Double
Attribute MinValue.VB_Description = "Returns/sets the mimimum allowable value."
Attribute MinValue.VB_ProcData.VB_Invoke_Property = ";Behavior"

    MinValue = mdblMinValue
    
End Property

Public Property Let MinValue(ByVal dblNew As Double)

    '******* 1.13 Start *******
'    If dblNew > MaxValue Then
    If dblNew > MaxValue And dblNew <> 0 Then
    '******* 1.13 End *********
        MaxValue = dblNew
    End If

    mdblMinValue = dblNew
    PropertyChanged "MinValue"
    
End Property
'******* 1.9 End *********
'******* 1.16a Start *******
Public Property Get RequireLeadingDigit() As Boolean
Attribute RequireLeadingDigit.VB_Description = "Returns/sets a value which determines whether the number must have at least one digit before the decimal separator."

    RequireLeadingDigit = mbRequireLD
    
End Property

Public Property Let RequireLeadingDigit(ByVal bTF As Boolean)

    mbRequireLD = bTF
    PropertyChanged "RequireLeadingDigit"
    
End Property
'******* 1.16a End *********

